<?php


abstract class BaseObjetosGastoPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'OBJETOS_GASTO';

	
	const CLASS_DEFAULT = 'lib.model.ObjetosGasto';

	
	const NUM_COLUMNS = 5;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'OBJETOS_GASTO.ID';

	
	const ANO_FISCAL = 'OBJETOS_GASTO.ANO_FISCAL';

	
	const CODIGO = 'OBJETOS_GASTO.CODIGO';

	
	const DESCRIPCION = 'OBJETOS_GASTO.DESCRIPCION';

	
	const ABREVIATURA = 'OBJETOS_GASTO.ABREVIATURA';

        const COMISION = 'OBJETOS_GASTO.COMISION';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'AnoFiscal', 'Codigo', 'Descripcion', 'Abreviatura','Comision', ),
		BasePeer::TYPE_COLNAME => array (ObjetosGastoPeer::ID, ObjetosGastoPeer::ANO_FISCAL, ObjetosGastoPeer::CODIGO, ObjetosGastoPeer::DESCRIPCION, ObjetosGastoPeer::ABREVIATURA,ObjetosGastoPeer::COMISION, ),
		BasePeer::TYPE_FIELDNAME => array ('ID', 'ANO_FISCAL', 'CODIGO', 'DESCRIPCION', 'ABREVIATURA', 'COMISION',),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4,5,)
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'AnoFiscal' => 1, 'Codigo' => 2, 'Descripcion' => 3, 'Abreviatura' => 4,'Comision' => 5, ),
		BasePeer::TYPE_COLNAME => array (ObjetosGastoPeer::ID => 0, ObjetosGastoPeer::ANO_FISCAL => 1, ObjetosGastoPeer::CODIGO => 2, ObjetosGastoPeer::DESCRIPCION => 3, ObjetosGastoPeer::ABREVIATURA => 4,ObjetosGastoPeer::COMISION => 5, ),
		BasePeer::TYPE_FIELDNAME => array ('ID' => 0, 'ANO_FISCAL' => 1, 'CODIGO' => 2, 'DESCRIPCION' => 3, 'ABREVIATURA' => 4, 'COMISION' => 5, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4,5,)
	);

	
	public static function getMapBuilder()
	{
		return BasePeer::getMapBuilder('lib.model.map.ObjetosGastoMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = ObjetosGastoPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(ObjetosGastoPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(ObjetosGastoPeer::ID);

		$criteria->addSelectColumn(ObjetosGastoPeer::ANO_FISCAL);

		$criteria->addSelectColumn(ObjetosGastoPeer::CODIGO);

		$criteria->addSelectColumn(ObjetosGastoPeer::DESCRIPCION);

		$criteria->addSelectColumn(ObjetosGastoPeer::ABREVIATURA);

                $criteria->addSelectColumn(ObjetosGastoPeer::COMISION);

	}

	const COUNT = 'COUNT(OBJETOS_GASTO.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT OBJETOS_GASTO.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(ObjetosGastoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(ObjetosGastoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = ObjetosGastoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = ObjetosGastoPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return ObjetosGastoPeer::populateObjects(ObjetosGastoPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			ObjetosGastoPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = ObjetosGastoPeer::getOMClass();
		$cls = sfPropel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

  static public function getUniqueColumnNames()
  {
    return array();
  }
	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return ObjetosGastoPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(ObjetosGastoPeer::ID);
			$selectCriteria->add(ObjetosGastoPeer::ID, $criteria->remove(ObjetosGastoPeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(ObjetosGastoPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(ObjetosGastoPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof ObjetosGasto) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(ObjetosGastoPeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(ObjetosGasto $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(ObjetosGastoPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(ObjetosGastoPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(ObjetosGastoPeer::DATABASE_NAME, ObjetosGastoPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = ObjetosGastoPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(ObjetosGastoPeer::DATABASE_NAME);

		$criteria->add(ObjetosGastoPeer::ID, $pk);


		$v = ObjetosGastoPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(ObjetosGastoPeer::ID, $pks, Criteria::IN);
			$objs = ObjetosGastoPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseObjetosGastoPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			Propel::registerMapBuilder('lib.model.map.ObjetosGastoMapBuilder');
}
